// DATETYPE.H                   Fejlc llomny a dtum tpus hasznlathoz.
// Fejleszt rendszer : BORLAND C++ 3.1
// Ksztette : Nagy Sndor, GAMF Informatika Tanszk
//              6000 Kecskemt Izski t 10.   Tel : (76) 481-291/175,178

#define JULCONST   1720982

#define YES        1
#define NO         0

// Struktra dtum informcik trolshoz.

struct DateRec{
   int Year,Month,Day;
};

// Bitmez szerkezet dtum megjelentsi formtum trolshoz.

struct Format{
   unsigned IsLongYear  : 1;
   unsigned IsNumMonth  : 1;
   unsigned IsDayName   : 1;
   unsigned Separator   : sizeof(char)*8;
};

// A dtumfunkcikat megvalst osztly

class Date{
   protected :
      long int JulianDays;              // A Julin napok szma.
      Format DateFormat;                // A megjelents formtuma.
      long int RecToJul(DateRec);
      char *CreateDateString();
   public :
      Date();
      Date(unsigned long int);
      Date(DateRec);
      void SetDateFormat(unsigned LongYear=YES, unsigned NumMonth=YES,
			 unsigned DayName=NO,   unsigned Sep='.');
      long int GetJulDay() { return(JulianDays); };
      void GetDate(DateRec&);
      int GetDayOfWeek();
      char* GetDateString();
      Date& operator=(long int);
      Date& operator=(DateRec&);
      Date& operator+(long int);
      Date& operator+=(long int);
      Date& operator-(long int);
      long int operator-(Date&);
      Date &operator-=(long int);
      Date& operator++();
      Date& operator--();
      int operator<(Date&);
      int operator<=(Date&);
      int operator==(Date&);
      int operator>(Date&);
      int operator>=(Date&);
      int operator!=(Date&);
};

