#include <stdlib.h>
#include <string.h>
#include <stdio.h>
#include <conio.h>
#include <io.h>
#include <fcntl.h>
#include <errno.h>
#include <alloc.h>
#include <dos.h>
#include <ctype.h>
#include <sys\stat.h>

#include "zzdata.h"
#include "zzcode.h"

//#include "..\LZW\LZW4C.h"

#include "..\xmem.h"

/**************/
/* Read-Write fn-s for compression */
struct srw
 {
  int h;
  char huge *mem;
  char huge *mpos;
  long rc;
  long wc;
  long rtmc;
  long si;
  long whstart;
  long mennyit;
  s_fdentry sf;
  int whandle;
 }
  rw;

char rt[4001];
int rtc;


int InitRW( int fi, char huge *hova, s_fdentry* sf, int writef=0 )
{
 rw.h=fi;
 rw.mem=hova;
 rw.mpos=hova;
 memcpy(&rw.sf,sf,sizeof(s_fdentry));
 rw.rc=0;
 rw.wc=0;
 rw.rtmc=-1;
 rw.si=rw.sf.csize;
 rw.whstart=0;
 rw.mennyit=-1;
 rw.whandle=writef;
 rtc=-1;
 return(0);
}

int RWread( void )
{
 int yy;
 if ((rtc==rw.rtmc) || (rtc==-1))
  {
   rtc=0;
   if (rw.si<=0)
    return(-1);

   yy=read(rw.h,rt,(4000>rw.si)?rw.si:4000);
   rw.si-=(4000>rw.si)?rw.si:4000;
   rw.rtmc=yy;
  }

 yy=rt[rtc];
 yy=yy&0x00FF; // not necessary .?
 rtc++;
 rw.rc++;
 return yy;
}

int RWwrite( int mit )
{
 if (rw.whstart>0)
  {
   rw.whstart--;
   return(0);
  }

 if (rw.mennyit==0)
  return 0;
 if (rw.mennyit>(-1))
  rw.mennyit--;

 *rw.mpos=mit;
 rw.mpos++;
 rw.wc++;
 return (0);
}

int RWwritefile( int mit )
{
 unsigned int xx;

 if ((mit==-1)||((rw.mpos-rw.mem)>=10240))
  {
   _dos_write(rw.whandle,rw.mem,(rw.mpos-rw.mem),&xx);
   rw.mpos=rw.mem;
  }

 if (rw.whstart>0)
  {
   rw.whstart--;
   return(0);
  }

 if (rw.mennyit==0)
  return 0;
 if (rw.mennyit>(-1))
  rw.mennyit--;

 *rw.mpos=mit;
 rw.mpos++;
 rw.wc++;
 return (0);
}


/**************/

int isZZLite; // YOU must set it ! ( or zf.open() will! )

char dsazon[10+1]={" < &%$^"};

int czdf::open( char *filename )
{
 //InitLZW((char*(*)())malloc);
 //***InitLZW((char *(*)())malloc);
 if (filename)
  dfh = ::open(filename,O_BINARY|O_RDONLY);
 else
  dfh = ::open("ZIGZAG.EXE",O_BINARY|O_RDONLY);
 if (dfh==-1)
  return(-1);

 char buf[10];
 lseek(dfh,filelength(dfh)-10,SEEK_SET);
 read(dfh,buf,10);
 if (memcmp(buf,dsazon,10))
  return -1;

 lseek(dfh,filelength(dfh)-14,SEEK_SET);
 read(dfh,&datastart,4);

 lseek(dfh,datastart,SEEK_SET);
 read(dfh,&head,sizeof(head));
 isZZLite = head.isZZLite;
 return(0);
}

void czdf::close( void )
{
 ::close(dfh);
 //****TermLZW((int(*)())free);
}

void czdf::get_header( sheader *sh )
{
 lseek(dfh,0+datastart,SEEK_SET);
 read(dfh,sh,sizeof(sheader));
}

long czdf::getsize( char *fnev )
{
 char *s;
 int c;
 s_fdentry de;

 for ( c=0,s=fnev ; (c<100) && *s!=0 ; s++,c++ ) *s=toupper(*s);

 lseek(dfh,sizeof(head)+datastart,SEEK_SET);
 for ( c=0 ; c<=head.dirents ; c++ )
  {
   read(dfh,&de,sizeof(de));
   if ( strncmp(de.name,fnev,12)!=0 )
    continue;
   return(de.size);
  }

 return(-1);
}

int czdf::far_readfile( char *fnev, char huge *buf )
{
 char *s;
 int c;
 s_fdentry de;
 unsigned xx;
 char last;
 char hanyadek;
 char huge *hs;
 long chklong;

 for ( c=0,s=fnev ; (c<100) && *s!=0 ; s++,c++ ) *s=toupper(*s);

 lseek(dfh,sizeof(head)+datastart,SEEK_SET);
 for ( c=0 ; c<=head.dirents ; c++ )
  {
   read(dfh,&de,sizeof(de));
   if ( strncmp(de.name,fnev,12)!=0 )
    continue;

   if ( de.method==0 )
    {
     if ( de.size<64000 )
      {
       lseek(dfh,de.start,SEEK_SET);
       _dos_read( dfh,buf,de.size,&xx );

       last=DEFINIALTLAST;  hanyadek=0;
       decodetomb(buf,de.size,&last,&hanyadek);
       _fmemcpy(&chklong , &buf[de.size-sizeof(long)],sizeof(long) );
      }
     else
      {
       long left;
       left=de.size;
       long most;
       last=DEFINIALTLAST;  hanyadek=0;
       lseek(dfh,de.start,SEEK_SET);
       hs=buf;

       while ( left>0 )
	{
	 most = (left<64000) ? left : 64000;
	 left-=most;
	 _dos_read( dfh,hs,most,&xx );
	 decodetomb(hs,most,&last,&hanyadek);
	 hs+=most;
	}
       _fmemcpy(&chklong , &hs[most-sizeof(long)],sizeof(long) );
      }
     if (chklong!=de.chksum)
      return(-2); // ERROR - file changed !!!!

     return(0);
    }

   if ( de.method==2 ) // compressed
    {
     lseek(dfh,de.start,SEEK_SET);
     InitRW(dfh,buf,&de);
     // ***LZW!! xx=Expand(RWread,(int(*)())RWwrite);
     return(0); // !! file changed - check is _not_ implemented here
    }
  }
 return(-1); // file not found
}

void czdf::writetofile( char *mitfnev, char *hovafnev )
{
 char *s;
 int c;
 s_fdentry de;
 unsigned xx;
 char last;
 char hanyadek;
 long cn1,cn2;
 int fh;
 char far *buf;

 for ( c=0,s=mitfnev ; (c<100) && *s!=0 ; s++,c++ ) *s=toupper(*s);

 lseek(dfh,sizeof(head)+datastart,SEEK_SET);
 for ( c=0 ; c<=head.dirents ; c++ )
  {
   read(dfh,&de,sizeof(de));
   if ( strncmp(de.name,mitfnev,12)!=0 )
    continue;

   ///-----------------------///
   buf=(char far *)xalloc(15003);

   fh = ::open(hovafnev,O_RDWR|O_BINARY|O_TRUNC|O_CREAT,S_IREAD|S_IWRITE);
   cn1=de.size;

   if (de.method==0)
    {
     lseek(dfh,de.start,SEEK_SET);
     last=DEFINIALTLAST;  hanyadek=0;
     while( cn1>0 )
      {
       cn2=(cn1>15000) ? 15000 : cn1;
       cn1-=cn2;
						// Ita rakta -=====[<>
       _dos_read( dfh,buf,cn2,&xx );
       xx=errno;

       decodetomb(buf,cn2,&last,&hanyadek);

       //for (d=0 ; d<cn2 ; d++ ) csum+=buf[d]; //csum+=buf[d]*((d%50)*2);

       _dos_write(fh,buf,cn2,&xx );
       xx=errno;

      }
    }

   if ( de.method==2 ) // compressed
    {
     lseek(dfh,de.start,SEEK_SET);
     InitRW(dfh,buf,&de,fh);
     // LZW !! xx=Expand(RWread,(int(*)())RWwritefile);
     RWwritefile(-1);
     return;
    }

   ::close(fh);
   xfree(buf);
   ///-----------------------///
   return;
  }
 return;
}


void czdf::far_specreadfile( char *fnev, char huge *buf , long honnan , long mennyit )
{                                                // honnan: !must be <64K!
 char *s;
 int c;
 s_fdentry de;
 unsigned xx;
 char last;
 char hanyadek;
 char huge *hs;

 for ( c=0,s=fnev ; (c<100) && *s!=0 ; s++,c++ ) *s=toupper(*s);

 lseek(dfh,sizeof(head)+datastart,SEEK_SET);
 for ( c=0 ; c<=head.dirents ; c++ )
  {
   read(dfh,&de,sizeof(de));
   if ( strncmp(de.name,fnev,12)!=0 )
    continue;

   if ( de.method==0 )
    {
     lseek(dfh,de.start,SEEK_SET);
     _dos_read( dfh,buf,honnan,&xx );
     last=DEFINIALTLAST;  hanyadek=0;
     decodetomb(buf,honnan,&last,&hanyadek);
     de.size-=honnan;
     de.start+=honnan;
     if (mennyit != 0) // -- spec read
      de.size=mennyit; // in this case last 4 byte check not available !

     if ( de.size<64000 )
      {
       lseek(dfh,de.start,SEEK_SET);
       _dos_read( dfh,buf,de.size,&xx );

       //last=DEFINIALTLAST;  hanyadek=0;
       decodetomb(buf,de.size,&last,&hanyadek);
      }
     else
      {
       long left;
       left=de.size;
       long most;
       //last=DEFINIALTLAST;  hanyadek=0;
       lseek(dfh,de.start,SEEK_SET);
       hs=buf;

       while ( left>0 )
	{
	 most = (left<64000) ? left : 64000;
	 left-=most;
	 _dos_read( dfh,hs,most,&xx );
	 decodetomb(hs,most,&last,&hanyadek);
	 hs+=most;
	}
      }

     return;
    }

   if (de.method==2)
    {
     lseek(dfh,de.start,SEEK_SET);
     InitRW(dfh,buf,&de);
     rw.whstart=honnan;
     rw.mennyit=(mennyit==0)?-1:mennyit;
     // LZW !!! xx=Expand(RWread,(int(*)())RWwrite);
     return; // !! file changed - check is _not_ implemented here
    }
  }
 return;
}
